#!/usr/bin/perl
#This program assumes that the old_dict & new dict are sorted alphabetically.
#If an entry is found for a word in both old_dict & new_dict, 
# old_dict entry is replaced by new_dict entry.
# The corresponding old_dict entries are stored in ERR_file.
# uncommon entries of old & new dict are retained without any change.
# usage : dict_update.pl <old_dict> <new_dict> <ERR_file> <updated_file>
open(D1,$ARGV[0]);
open(D2,$ARGV[1]);
open(ERRLOG,">$ARGV[2]");
open(D_OUT,">$ARGV[3]");
$in1 = <D1>;
($old_wrd,$old_pdgm,$old_cat,$old_mng,$old_dict) = split(/,/,$in1);
$in2 = <D2>;
($wrd,$pdgm,$cat,$mng,$dict) = split(/,/,$in2);
$flag1 = 1;
$flag2 = 1;
while($flag1 && $flag2)
{
while(($old_wrd lt $wrd) && $flag1) { # retain all the unchanged words
print D_OUT $in1;
$in1 = <D1>; 
if(!$in1){ $flag1 = 0;}
($old_wrd,$old_pdgm,$old_cat,$old_mng,$old_dict) = split(/,/,$in1);
}
if($wrd eq $old_wrd)
{
print ERRLOG $in1; # Store the old entry in log file
print D_OUT $in2; # replace old entry by new one
$in1 = <D1>; 
if(!$in1){ $flag1 = 0;}
($old_wrd,$old_pdgm,$old_cat,$old_mng,$old_dict) = split(/,/,$in1);
$in2 = <D2>;
if(!$in2){ $flag2 = 0;}
($wrd,$pdgm,$cat,$mng,$dict) = split(/,/,$in2);
}
while(($old_wrd gt $wrd) && ($flag2)) { # Add all the new words
print D_OUT $in2;
$in2 = <D2>;
if(!$in2){ $flag2 = 0;}
($wrd,$pdgm,$cat,$mng,$dict) = split(/,/,$in2);
}
}
if(($flag2 == 0) && $flag1)
{ # new words exausted ; copy all the remaining old words
print D_OUT $in1;
while($in1 = <D1>) { print D_OUT $in1;}
}
if(($flag1 == 0) && $flag2)
{
# old words exausted ; copy all the remaining new words
print D_OUT $in2;
while($in2 = <D2>) { print D_OUT $in2; }
}
