require "/home/bharathi/A-H/amba/tools/src/morph/get_comm_wrds.pl";
require "/home/bharathi/A-H/amba/tools/src/morph/decide_pdgm_stats.pl";
require "/home/bharathi/A-H/amba/tools/src/morph/decide_pdgm_heuri.pl";
local($vowel,$cons);
$vowel = "aeiouAEIOU";
$cons = "kctwpgjdxbKCTWPGJDXByrlvsSRhmnNY";
sub noun_pdgm
{
local($in,$corpus,$allwd_err) = @_;
#print $in,",",$corpus,",",$allwd_err,"\n";
local($ans,@sum_ar,@pdgm_ar);
if($in =~ /a$/)
  {
   $ans = "kota";
  }
elsif($in =~ /[AIUeEoO]$/)
  {
   $ans = "rikRA";
  }
elsif($in =~ /eV$/)
  {
   $ans = "peVtteV";
  }
# oV ending words are not found in dict
elsif($in =~ /[aA]M$/)
  {
   $ans = "puswakaM";
  }
elsif($in =~ /uM$/)
  {
   $ans = "meku"; # hukuM-> hukumulu Present pdgm does not handle this.
  }
elsif($in =~ /eV?M$/)
  {
   $ans = "paMxeVM";
  }
# [iIUEoO]M ending words not found in dict
elsif($in =~ /pUvu$/)
  {
   $ans = "pUvu";
  }
elsif($in =~ /vu$/)
  {
   $ans = "meku";
  }
elsif($in =~ /ku$/)
  {
   $ans = "meku";
  }
elsif($in =~ /rAttu$/)
  {
   $ans = "meku";
  }
elsif($in =~ /ttu$/)
  {
   $ans = "koVttu";
  }
elsif($in =~ /Mtu$/)
  {
   $ans = "beVMdu";
  }
elsif($in =~ /[kcwpKCTWPgjdxbGJDXByrlvsSRhmNY]tu$/)
  {
   $ans = "meku";
  }
elsif($in =~ /[aeiouAEIOUV]tu$/)
  {
   $ans = "kotu";
  }
elsif($in =~ /llu$/)
{
$sum_ar[0] = &get_comm_wrds($in,"illu",$corpus);
#print $sum_ar[0];
$sum_ar[1] = &get_comm_wrds($in,"meku",$corpus);
@pdgm_ar = ("illu","meku");
$ans = &decide_pdgm_stats(@sum_ar,":",@pdgm_ar,":",2,":",$allwd_err);
$ans1 = &decide_llu($in,$corpus);
$ans = $ans.":".$ans1;
}
elsif($in =~ /lu$/)
  {
   $ans = "velu";
  }
elsif($in =~ /nnu$/)
{
$sum_ar[0] = &get_comm_wrds($in,"kannu",$corpus);
$sum_ar[1] = &get_comm_wrds($in,"meku",$corpus);
@pdgm_ar = ("kannu","meku");
$ans = &decide_pdgm_stats(@sum_ar,":",@pdgm_ar,":",2,":",$allwd_err);
$ans1 =&decide_nnu($in,$corpus);
$ans = $ans.":".$ans1;
}
elsif($in =~ /nu$/)
{
$sum_ar[0] = &get_comm_wrds($in,"bonu",$corpus);
$sum_ar[1] = &get_comm_wrds($in,"cenu",$corpus);
$sum_ar[2] = &get_comm_wrds($in,"meku",$corpus);
@pdgm_ar = ("bonu","cenu","meku");
$ans = &decide_pdgm_stats(@sum_ar,":",@pdgm_ar,":",3,":",$allwd_err);
$ans1 =&decide_nu($in,$corpus);
$ans = $ans.":".$ans1;
}
elsif($in =~ /rru$/)
 {
 $ans = "meku";
 }
elsif($in =~ /ru$/)
{
$sum_ar[0] = &get_comm_wrds($in,"nOkaru",$corpus);
$sum_ar[1] = &get_comm_wrds($in,"goru",$corpus);
$sum_ar[2] = &get_comm_wrds($in,"Uru",$corpus);
$sum_ar[3] = &get_comm_wrds($in,"vexuru",$corpus);
@pdgm_ar = ("nOkaru","goru","Uru","vexuru");
$ans = &decide_pdgm_stats(@sum_ar,":",@pdgm_ar,":",4,":",$allwd_err);
$ans1 =&decide_ru($in,$corpus);
$ans = $ans.":".$ans1;
}
elsif($in =~ /Mdu$/)
{
$sum_ar[0] = &get_comm_wrds($in,"guMdu",$corpus);
$sum_ar[1] = &get_comm_wrds($in,"beVMdu",$corpus);
@pdgm_ar = ("guddu","beVMdu");
$ans = &decide_pdgm_stats(@sum_ar,":",@pdgm_ar,":",2,":",$allwd_err);
$ans1 =&decide_Mdu($in,$corpus);
$ans = $ans.":".$ans1;
}
elsif($in =~ /[kctwpKCTWPgjxbGJDXBylvsSRhYmNn]du$/)
{
$ans = "gaxi";
}
elsif($in =~ /ddu$/)
{
$ans = "guddu";
}
elsif($in =~ /[aeiouAEIOUV]du$/)
{
$sum_ar[0] = &get_comm_wrds($in,"pillavAdu",$corpus);
$sum_ar[1] = &get_comm_wrds($in,"gUdu",$corpus);
$sum_ar[2] = &get_comm_wrds($in,"bAludu",$corpus);
$sum_ar[3] = &get_comm_wrds($in,"snehiwudu",$corpus);
$sum_ar[4] = &get_comm_wrds($in,"guddu",$corpus);
@pdgm_ar = ("pillavAdu","gUdu","bAludu","snehiwudu","guddu");
$ans = &decide_pdgm_stats(@sum_ar,":",@pdgm_ar,":",5,":",$allwd_err);
$ans1 =&decide_vowel_du($in,$corpus);
$ans = $ans.":".$ans1;
}
elsif($in =~ /u$/)
  { 
   $ans = "meku";
  }
elsif($in =~ /Ni$/)
  {
   $ans = "rANi";
  }
elsif($in =~ /[$vowel]ni$/)
  {
   $ans = "pani";
  }
elsif($in =~ /[$cons]ni$/)
  {
   $ans = "gaxi";
  }
elsif($in =~ /tti$/)
  {
   $ans = "buddi";
  }
elsif($in =~ /Mti$/)
  {
   $ans = "piMdi";
  }
elsif($in =~ /[$cons]ti$/)
  {
   $ans = "gaxi";
  }
elsif($in =~ /ti$/)
  {
   $ans = "koti";
  }
elsif($in =~ /[$cons]ri/)
 {
$ans = "gaxi";
 }
elsif($in =~ /ri$/)
{
$sum_ar[0] = &get_comm_wrds($in,"paMxiri",$corpus);
$sum_ar[1] = &get_comm_wrds($in,"gaxi",$corpus);
$sum_ar[2] = &get_comm_wrds($in,"xAri",$corpus);
$sum_ar[3] = &get_comm_wrds($in,"rAwri",$corpus);
@pdgm_ar = ("paMxiri","giri","xAri","rAwri");
$ans = &decide_pdgm_stats(@sum_ar,":",@pdgm_ar,":",4,":",$allwd_err);
$ans1 =&decide_ri($in,$corpus);
$ans = $ans.":".$ans1;
}
elsif($in =~ /yi$/)
{
$sum_ar[0] = &get_comm_wrds($in,"xrAyi",$corpus);
$sum_ar[1] = &get_comm_wrds($in,"veyi",$corpus);
$sum_ar[2] = &get_comm_wrds($in,"goyi",$corpus);
$sum_ar[3] = &get_comm_wrds($in,"abbAyi",$corpus);
@pdgm_ar = ("xrAyi","veyi","goyi","abbAyi");
$ans = &decide_pdgm_stats(@sum_ar,":",@pdgm_ar,":",4,":",$allwd_err);
$ans1 =&decide_yi($in,$corpus);
$ans = $ans.":".$ans1;
}
elsif($in =~ /[dl]li/)
 {
  $ans = "gaxi";
 }
elsif($in =~ /peVlYli/)
 {
  $ans = "rAwri";
 }
elsif($in =~ /lYli/)
 {
  $ans = "gaxi";
 }
elsif($in =~ /li$/)
{
$sum_ar[0] = &get_comm_wrds($in,"wiragali",$corpus);
$sum_ar[1] = &get_comm_wrds($in,"puli",$corpus);
@pdgm_ar = ("wiragali","puli");
$ans = &decide_pdgm_stats(@sum_ar,":",@pdgm_ar,":",2,":",$allwd_err);
$ans1 =&decide_li($in,$corpus);
$ans = $ans.":".$ans1;
}
elsif($in =~ /Mdi$/)
{
$sum_ar[0] = &get_comm_wrds($in,"baMdi",$corpus);
$sum_ar[1] = &get_comm_wrds($in,"piMdi",$corpus);
@pdgm_ar = ("baMdi","piMdi");
$ans = &decide_pdgm_stats(@sum_ar,":",@pdgm_ar,":",2,":",$allwd_err);
$ans1 =&decide_Mdi($in,$corpus);
$ans = $ans.":".$ans1;
}
elsif($in =~ /ddi$/)
{ 
$ans = "buddi";
}
elsif($in =~ /[aeiouAEIOUV]di$/)
{
$ans = "gudi";
}
elsif($in =~ /i$/)
{
$ans = "gaxi";
}
# there are no words with [^aeiouAEIOUVMd]di]$.
}
$ans;
1;
